"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function isFunctionComponent(t, node) {
  return t.isTSTypeAnnotation(node.typeAnnotation) && t.isTSTypeReference(node.typeAnnotation.typeAnnotation) && t.isIdentifier(node.typeAnnotation.typeAnnotation.typeName) && (node.typeAnnotation.typeAnnotation.typeName.name === 'FC' || node.typeAnnotation.typeAnnotation.typeName.name === 'FunctionComponent');
}

function isComponentFactory(t, node) {
  return t.isCallExpression(node.init) && t.isIdentifier(node.init.callee) && (node.init.callee.name === 'forwardRef' || node.init.callee.name === 'memo');
}

function _default({
  types: t
}) {
  return {
    visitor: {
      VariableDeclarator(path) {
        if (!t.isIdentifier(path.node.id)) return;
        if (!isFunctionComponent(t, path.node.id) && !isComponentFactory(t, path.node)) return; // add displayName member to the component

        path.parentPath.insertAfter(t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.identifier(path.node.id.name), t.identifier('displayName')), t.stringLiteral(path.node.id.name))));
      }

    }
  };
}